From 57a61af00d82a171ec7263f08bd3973ba4a5922b Mon Sep 17 00:00:00 2001
From: Stephen Gallagher <sgallagh@redhat.com>
Date: Wed, 17 Feb 2010 10:34:34 -0500
Subject: [PATCH 2/3] Merge sss_client and sss_daemon translations together

---
 contrib/sssd.spec.in       |    3 +-
 server/po/LINGUAS          |    1 +
 server/po/de.po            |   46 +++++++++++++++++++++++++++++-
 server/po/es.po            |   47 ++++++++++++++++++++++++++++--
 server/po/{nl.po => fr.po} |   68 ++++++++++++++++++++++++++++++++++++--------
 server/po/it.po            |   47 +++++++++++++++++++++++++++++-
 server/po/ja.po            |   46 +++++++++++++++++++++++++++++-
 server/po/nl.po            |   47 +++++++++++++++++++++++++++++-
 server/po/pl.po            |   47 +++++++++++++++++++++++++++++-
 server/po/pt.po            |   47 +++++++++++++++++++++++++++++-
 server/po/sss_daemon.pot   |   46 +++++++++++++++++++++++++++++-
 server/po/sv.po            |   47 +++++++++++++++++++++++++++++-
 12 files changed, 467 insertions(+), 25 deletions(-)
 copy server/po/{nl.po => fr.po} (90%)

diff --git a/contrib/sssd.spec.in b/contrib/sssd.spec.in
index f6179d1..8c38146 100644
--- a/contrib/sssd.spec.in
+++ b/contrib/sssd.spec.in
@@ -219,7 +219,6 @@ rm -f \
 
 # Prepare language files
 /usr/lib/rpm/find-lang.sh $RPM_BUILD_ROOT sss_daemon
-/usr/lib/rpm/find-lang.sh $RPM_BUILD_ROOT sss_client
 
 # Copy default sssd.conf file
 mkdir -p $RPM_BUILD_ROOT/%{_sysconfdir}/sssd
@@ -301,7 +300,7 @@ rm -rf $RPM_BUILD_ROOT
 %{python_sitelib}/*.py*
 
 
-%files client -f sss_client.lang
+%files client
 %defattr(-,root,root,-)
 /%{_lib}/libnss_sss.so.2
 /%{_lib}/security/pam_sss.so
diff --git a/server/po/LINGUAS b/server/po/LINGUAS
index 376d98d..f2c4e4c 100644
--- a/server/po/LINGUAS
+++ b/server/po/LINGUAS
@@ -6,4 +6,5 @@ pt
 de
 sv
 it
+fr
 
diff --git a/server/po/de.po b/server/po/de.po
index 06bab21..3ec1a9a 100644
--- a/server/po/de.po
+++ b/server/po/de.po
@@ -8,7 +8,7 @@ msgid ""
 msgstr ""
 "Project-Id-Version: SSS\n"
 "Report-Msgid-Bugs-To: sssd-devel@lists.fedorahosted.org\n"
-"POT-Creation-Date: 2010-02-05 09:37-0500\n"
+"POT-Creation-Date: 2010-02-17 09:21-0500\n"
 "PO-Revision-Date: 2009-12-09 11:13+0100\n"
 "Last-Translator: Fabian Affolter <fab@fedoraproject.org>\n"
 "Language-Team: German <fedora-trans-de@redhat.com>\n"
@@ -646,3 +646,47 @@ msgstr ""
 #: tools/sss_usermod.c:249
 msgid "Transaction error. Could not modify user.\n"
 msgstr ""
+
+#: sss_client/pam_sss.c:342
+msgid "Passwords do not match"
+msgstr ""
+
+#: sss_client/pam_sss.c:411
+msgid "Offline authentication"
+msgstr ""
+
+#: sss_client/pam_sss.c:412
+msgid ", your cached password will expire at: "
+msgstr ""
+
+#: sss_client/pam_sss.c:462
+msgid "Offline authentication, authentication is denied until: "
+msgstr ""
+
+#: sss_client/pam_sss.c:489
+msgid "System is offline, password change not possible"
+msgstr ""
+
+#: sss_client/pam_sss.c:519
+msgid "Password change failed. "
+msgstr ""
+
+#: sss_client/pam_sss.c:520
+msgid "Server message: "
+msgstr ""
+
+#: sss_client/pam_sss.c:855
+msgid "Password: "
+msgstr ""
+
+#: sss_client/pam_sss.c:887
+msgid "New Password: "
+msgstr ""
+
+#: sss_client/pam_sss.c:888
+msgid "Reenter new Password: "
+msgstr ""
+
+#: sss_client/pam_sss.c:1092
+msgid "Password has expired."
+msgstr ""
diff --git a/server/po/es.po b/server/po/es.po
index 9b175e6..36a6de0 100644
--- a/server/po/es.po
+++ b/server/po/es.po
@@ -7,7 +7,7 @@ msgid ""
 msgstr ""
 "Project-Id-Version: sss_daemon 0.4.0\n"
 "Report-Msgid-Bugs-To: sssd-devel@lists.fedorahosted.org\n"
-"POT-Creation-Date: 2010-02-05 09:37-0500\n"
+"POT-Creation-Date: 2010-02-17 09:21-0500\n"
 "PO-Revision-Date: 2009-12-11 12:00-0300\n"
 "Last-Translator: Domingo Becker <domingobecker@gmail.com>\n"
 "Language-Team: Transifex Spanish\n"
@@ -674,6 +674,47 @@ msgstr ""
 msgid "Transaction error. Could not modify user.\n"
 msgstr "Error de transacción. No se pudo modificar el usuario.\n"
 
+#: sss_client/pam_sss.c:342
+msgid "Passwords do not match"
+msgstr "Las contraseñas no coinciden"
+
+#: sss_client/pam_sss.c:411
+msgid "Offline authentication"
+msgstr ""
+
+#: sss_client/pam_sss.c:412
+msgid ", your cached password will expire at: "
+msgstr ""
+
+#: sss_client/pam_sss.c:462
+msgid "Offline authentication, authentication is denied until: "
+msgstr ""
+
+#: sss_client/pam_sss.c:489
+msgid "System is offline, password change not possible"
+msgstr ""
+
+#: sss_client/pam_sss.c:519
 #, fuzzy
-#~ msgid "A user with the same name or UID already exists\n"
-#~ msgstr "The user %s already exists\n"
+msgid "Password change failed. "
+msgstr "Proveedor de cambio de contraseña"
+
+#: sss_client/pam_sss.c:520
+msgid "Server message: "
+msgstr ""
+
+#: sss_client/pam_sss.c:855
+msgid "Password: "
+msgstr "Contraseña: "
+
+#: sss_client/pam_sss.c:887
+msgid "New Password: "
+msgstr "Nueva contraseña: "
+
+#: sss_client/pam_sss.c:888
+msgid "Reenter new Password: "
+msgstr "Reingrese la contraseña nueva:"
+
+#: sss_client/pam_sss.c:1092
+msgid "Password has expired."
+msgstr "La contraseña ha expirado."
diff --git a/server/po/nl.po b/server/po/fr.po
similarity index 90%
copy from server/po/nl.po
copy to server/po/fr.po
index c198e0e..5ad6651 100644
--- a/server/po/nl.po
+++ b/server/po/fr.po
@@ -1,21 +1,19 @@
-# translation of sssd.master.sss_daemon.po to Dutch
-# Copyright (C) YEAR Red Hat, Inc.
-# This file is distributed under the same license as the PACKAGE package.
+# French translation of SSS Client
+# Copyright (C) 2009 Red Hat, Inc.
+# This file is distributed under the same license as the SSSD package.
+# Pablo Martin-Gomez <pablo.martin-gomez@laposte.net>, 2009.
 #
-# Richard van der Luit <nippur@fedoraproject.org>, 2009.
 msgid ""
 msgstr ""
-"Project-Id-Version: sssd.master.sss_daemon\n"
+"Project-Id-Version: fr\n"
 "Report-Msgid-Bugs-To: sssd-devel@lists.fedorahosted.org\n"
-"POT-Creation-Date: 2010-02-05 09:37-0500\n"
-"PO-Revision-Date: 2009-11-19 12:19+0100\n"
-"Last-Translator: Richard van der Luit <nippur@fedoraproject.org>\n"
-"Language-Team: Dutch <nl@li.org>\n"
+"POT-Creation-Date: 2010-02-17 09:21-0500\n"
+"PO-Revision-Date: 2009-11-17 21:05+0100\n"
+"Last-Translator: Pablo Martin-Gomez <pablo.martin-gomez@laposte.net>\n"
+"Language-Team: Français <fedora-trans-fr@redhat.com>\n"
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=UTF-8\n"
 "Content-Transfer-Encoding: 8bit\n"
-"X-Generator: KBabel 1.11.4\n"
-"Plural-Forms:  nplurals=2; plural=(n != 1);\n"
 
 #: config/SSSDConfig.py:39
 msgid "Set the verbosity of the debug logging"
@@ -116,8 +114,9 @@ msgid "Access control provider"
 msgstr ""
 
 #: config/SSSDConfig.py:71
+#, fuzzy
 msgid "Password change provider"
-msgstr ""
+msgstr "Le mot de passe a expiré."
 
 #: config/SSSDConfig.py:74
 msgid "Minimum user ID"
@@ -646,3 +645,48 @@ msgstr ""
 #: tools/sss_usermod.c:249
 msgid "Transaction error. Could not modify user.\n"
 msgstr ""
+
+#: sss_client/pam_sss.c:342
+msgid "Passwords do not match"
+msgstr "Les mots de passe ne correspondent pas"
+
+#: sss_client/pam_sss.c:411
+msgid "Offline authentication"
+msgstr ""
+
+#: sss_client/pam_sss.c:412
+msgid ", your cached password will expire at: "
+msgstr ""
+
+#: sss_client/pam_sss.c:462
+msgid "Offline authentication, authentication is denied until: "
+msgstr ""
+
+#: sss_client/pam_sss.c:489
+msgid "System is offline, password change not possible"
+msgstr ""
+
+#: sss_client/pam_sss.c:519
+#, fuzzy
+msgid "Password change failed. "
+msgstr "Le mot de passe a expiré."
+
+#: sss_client/pam_sss.c:520
+msgid "Server message: "
+msgstr ""
+
+#: sss_client/pam_sss.c:855
+msgid "Password: "
+msgstr "Mot de passe : "
+
+#: sss_client/pam_sss.c:887
+msgid "New Password: "
+msgstr "Nouveau mot de passe : "
+
+#: sss_client/pam_sss.c:888
+msgid "Reenter new Password: "
+msgstr "Retaper le nouveau mot de passe : "
+
+#: sss_client/pam_sss.c:1092
+msgid "Password has expired."
+msgstr "Le mot de passe a expiré."
diff --git a/server/po/it.po b/server/po/it.po
index 8b21729..3d33128 100644
--- a/server/po/it.po
+++ b/server/po/it.po
@@ -7,7 +7,7 @@ msgid ""
 msgstr ""
 "Project-Id-Version: it\n"
 "Report-Msgid-Bugs-To: sssd-devel@lists.fedorahosted.org\n"
-"POT-Creation-Date: 2010-02-05 09:37-0500\n"
+"POT-Creation-Date: 2010-02-17 09:21-0500\n"
 "PO-Revision-Date: \n"
 "Last-Translator: Marina Latini <deneb.alphacygni@gmail.com>\n"
 "Language-Team: Italian <fedora-trans-it@redhat.com>\n"
@@ -655,3 +655,48 @@ msgstr "Impossibile modificare l'utente - utente già membro di gruppi?\n"
 #: tools/sss_usermod.c:249
 msgid "Transaction error. Could not modify user.\n"
 msgstr "Errore della transazione. Impossibile modificare l'utente.\n"
+
+#: sss_client/pam_sss.c:342
+msgid "Passwords do not match"
+msgstr "Le password non coincidono"
+
+#: sss_client/pam_sss.c:411
+msgid "Offline authentication"
+msgstr ""
+
+#: sss_client/pam_sss.c:412
+msgid ", your cached password will expire at: "
+msgstr ""
+
+#: sss_client/pam_sss.c:462
+msgid "Offline authentication, authentication is denied until: "
+msgstr ""
+
+#: sss_client/pam_sss.c:489
+msgid "System is offline, password change not possible"
+msgstr ""
+
+#: sss_client/pam_sss.c:519
+#, fuzzy
+msgid "Password change failed. "
+msgstr "La password è scaduta."
+
+#: sss_client/pam_sss.c:520
+msgid "Server message: "
+msgstr ""
+
+#: sss_client/pam_sss.c:855
+msgid "Password: "
+msgstr "Password: "
+
+#: sss_client/pam_sss.c:887
+msgid "New Password: "
+msgstr "Nuova password: "
+
+#: sss_client/pam_sss.c:888
+msgid "Reenter new Password: "
+msgstr "reinserire la nuova password: "
+
+#: sss_client/pam_sss.c:1092
+msgid "Password has expired."
+msgstr "La password è scaduta."
diff --git a/server/po/ja.po b/server/po/ja.po
index 3dcd848..4323f22 100644
--- a/server/po/ja.po
+++ b/server/po/ja.po
@@ -7,7 +7,7 @@ msgid ""
 msgstr ""
 "Project-Id-Version: sss_daemon_ja\n"
 "Report-Msgid-Bugs-To: sssd-devel@lists.fedorahosted.org\n"
-"POT-Creation-Date: 2010-02-05 09:37-0500\n"
+"POT-Creation-Date: 2010-02-17 09:21-0500\n"
 "PO-Revision-Date: 2009-11-18 09:48+1000\n"
 "Last-Translator: Noriko Mizumoto <noriko@fedoraproject.org>\n"
 "Language-Team: Japanese <fedora-trans-ja@redhat.com>\n"
@@ -646,3 +646,47 @@ msgstr ""
 #: tools/sss_usermod.c:249
 msgid "Transaction error. Could not modify user.\n"
 msgstr ""
+
+#: sss_client/pam_sss.c:342
+msgid "Passwords do not match"
+msgstr ""
+
+#: sss_client/pam_sss.c:411
+msgid "Offline authentication"
+msgstr ""
+
+#: sss_client/pam_sss.c:412
+msgid ", your cached password will expire at: "
+msgstr ""
+
+#: sss_client/pam_sss.c:462
+msgid "Offline authentication, authentication is denied until: "
+msgstr ""
+
+#: sss_client/pam_sss.c:489
+msgid "System is offline, password change not possible"
+msgstr ""
+
+#: sss_client/pam_sss.c:519
+msgid "Password change failed. "
+msgstr ""
+
+#: sss_client/pam_sss.c:520
+msgid "Server message: "
+msgstr ""
+
+#: sss_client/pam_sss.c:855
+msgid "Password: "
+msgstr ""
+
+#: sss_client/pam_sss.c:887
+msgid "New Password: "
+msgstr ""
+
+#: sss_client/pam_sss.c:888
+msgid "Reenter new Password: "
+msgstr ""
+
+#: sss_client/pam_sss.c:1092
+msgid "Password has expired."
+msgstr ""
diff --git a/server/po/nl.po b/server/po/nl.po
index c198e0e..e3dd47f 100644
--- a/server/po/nl.po
+++ b/server/po/nl.po
@@ -7,7 +7,7 @@ msgid ""
 msgstr ""
 "Project-Id-Version: sssd.master.sss_daemon\n"
 "Report-Msgid-Bugs-To: sssd-devel@lists.fedorahosted.org\n"
-"POT-Creation-Date: 2010-02-05 09:37-0500\n"
+"POT-Creation-Date: 2010-02-17 09:21-0500\n"
 "PO-Revision-Date: 2009-11-19 12:19+0100\n"
 "Last-Translator: Richard van der Luit <nippur@fedoraproject.org>\n"
 "Language-Team: Dutch <nl@li.org>\n"
@@ -646,3 +646,48 @@ msgstr ""
 #: tools/sss_usermod.c:249
 msgid "Transaction error. Could not modify user.\n"
 msgstr ""
+
+#: sss_client/pam_sss.c:342
+msgid "Passwords do not match"
+msgstr "Wachtwoorden komen niet overeen"
+
+#: sss_client/pam_sss.c:411
+msgid "Offline authentication"
+msgstr ""
+
+#: sss_client/pam_sss.c:412
+msgid ", your cached password will expire at: "
+msgstr ""
+
+#: sss_client/pam_sss.c:462
+msgid "Offline authentication, authentication is denied until: "
+msgstr ""
+
+#: sss_client/pam_sss.c:489
+msgid "System is offline, password change not possible"
+msgstr ""
+
+#: sss_client/pam_sss.c:519
+#, fuzzy
+msgid "Password change failed. "
+msgstr "Wachtwoord is verlopen."
+
+#: sss_client/pam_sss.c:520
+msgid "Server message: "
+msgstr ""
+
+#: sss_client/pam_sss.c:855
+msgid "Password: "
+msgstr "Wachtwoord: "
+
+#: sss_client/pam_sss.c:887
+msgid "New Password: "
+msgstr "Nieuw Wachtwoord: "
+
+#: sss_client/pam_sss.c:888
+msgid "Reenter new Password: "
+msgstr "Voer nieuw wachtwoord nogmaals in: "
+
+#: sss_client/pam_sss.c:1092
+msgid "Password has expired."
+msgstr "Wachtwoord is verlopen."
diff --git a/server/po/pl.po b/server/po/pl.po
index a85243e..dcbc72d 100644
--- a/server/po/pl.po
+++ b/server/po/pl.po
@@ -5,7 +5,7 @@ msgid ""
 msgstr ""
 "Project-Id-Version: pl\n"
 "Report-Msgid-Bugs-To: sssd-devel@lists.fedorahosted.org\n"
-"POT-Creation-Date: 2010-02-05 09:37-0500\n"
+"POT-Creation-Date: 2010-02-17 09:21-0500\n"
 "PO-Revision-Date: 2010-02-06 01:03+0100\n"
 "Last-Translator: Piotr Drąg <piotrdrag@gmail.com>\n"
 "Language-Team: Polish <trans-pl@lists.fedoraproject.org>\n"
@@ -671,3 +671,48 @@ msgstr ""
 #: tools/sss_usermod.c:249
 msgid "Transaction error. Could not modify user.\n"
 msgstr "Błąd transakcji. Nie można zmodyfikować użytkownika.\n"
+
+#: sss_client/pam_sss.c:342
+msgid "Passwords do not match"
+msgstr "Hasła nie zgadzają się"
+
+#: sss_client/pam_sss.c:411
+msgid "Offline authentication"
+msgstr "Uwierzytelnienie w trybie offline"
+
+#: sss_client/pam_sss.c:412
+msgid ", your cached password will expire at: "
+msgstr ", hasło w pamięci podręcznej wygaśnie za: "
+
+#: sss_client/pam_sss.c:462
+msgid "Offline authentication, authentication is denied until: "
+msgstr ""
+
+#: sss_client/pam_sss.c:489
+msgid "System is offline, password change not possible"
+msgstr ""
+
+#: sss_client/pam_sss.c:519
+#, fuzzy
+msgid "Password change failed. "
+msgstr "Dostawca zmiany hasła"
+
+#: sss_client/pam_sss.c:520
+msgid "Server message: "
+msgstr ""
+
+#: sss_client/pam_sss.c:855
+msgid "Password: "
+msgstr "Hasło: "
+
+#: sss_client/pam_sss.c:887
+msgid "New Password: "
+msgstr "Nowe hasło: "
+
+#: sss_client/pam_sss.c:888
+msgid "Reenter new Password: "
+msgstr "Proszę ponownie podać nowe hasło: "
+
+#: sss_client/pam_sss.c:1092
+msgid "Password has expired."
+msgstr "Hasło wygasło."
diff --git a/server/po/pt.po b/server/po/pt.po
index babb3c5..8f35958 100644
--- a/server/po/pt.po
+++ b/server/po/pt.po
@@ -7,7 +7,7 @@ msgid ""
 msgstr ""
 "Project-Id-Version: sssd.master.sss_daemon\n"
 "Report-Msgid-Bugs-To: sssd-devel@lists.fedorahosted.org\n"
-"POT-Creation-Date: 2010-02-05 09:37-0500\n"
+"POT-Creation-Date: 2010-02-17 09:21-0500\n"
 "PO-Revision-Date: 2009-12-08 18:06+0100\n"
 "Last-Translator: Rui Gouveia <rui.gouveia@globaltek.pt>\n"
 "Language-Team: PT <fedora-trans-pt@redhat.com>\n"
@@ -665,3 +665,48 @@ msgstr "Incapaz de modificar utilizador - utilizador já é membro de grupos?\n"
 #: tools/sss_usermod.c:249
 msgid "Transaction error. Could not modify user.\n"
 msgstr "Erro na transacção. Não foi possível modificar o utilizador.\n"
+
+#: sss_client/pam_sss.c:342
+msgid "Passwords do not match"
+msgstr "Senhas não coincidem"
+
+#: sss_client/pam_sss.c:411
+msgid "Offline authentication"
+msgstr ""
+
+#: sss_client/pam_sss.c:412
+msgid ", your cached password will expire at: "
+msgstr ""
+
+#: sss_client/pam_sss.c:462
+msgid "Offline authentication, authentication is denied until: "
+msgstr ""
+
+#: sss_client/pam_sss.c:489
+msgid "System is offline, password change not possible"
+msgstr ""
+
+#: sss_client/pam_sss.c:519
+#, fuzzy
+msgid "Password change failed. "
+msgstr "Fornecedor de Alteração de Senha"
+
+#: sss_client/pam_sss.c:520
+msgid "Server message: "
+msgstr ""
+
+#: sss_client/pam_sss.c:855
+msgid "Password: "
+msgstr "Senha: "
+
+#: sss_client/pam_sss.c:887
+msgid "New Password: "
+msgstr "Nova Senha: "
+
+#: sss_client/pam_sss.c:888
+msgid "Reenter new Password: "
+msgstr "Digite a senha novamente: "
+
+#: sss_client/pam_sss.c:1092
+msgid "Password has expired."
+msgstr "Senha expirou."
diff --git a/server/po/sss_daemon.pot b/server/po/sss_daemon.pot
index 76dc6fa..ec29a08 100644
--- a/server/po/sss_daemon.pot
+++ b/server/po/sss_daemon.pot
@@ -8,7 +8,7 @@ msgid ""
 msgstr ""
 "Project-Id-Version: PACKAGE VERSION\n"
 "Report-Msgid-Bugs-To: sssd-devel@lists.fedorahosted.org\n"
-"POT-Creation-Date: 2010-02-05 09:37-0500\n"
+"POT-Creation-Date: 2010-02-17 09:21-0500\n"
 "PO-Revision-Date: YEAR-MO-DA HO:MI+ZONE\n"
 "Last-Translator: FULL NAME <EMAIL@ADDRESS>\n"
 "Language-Team: LANGUAGE <LL@li.org>\n"
@@ -645,3 +645,47 @@ msgstr ""
 #: tools/sss_usermod.c:249
 msgid "Transaction error. Could not modify user.\n"
 msgstr ""
+
+#: sss_client/pam_sss.c:342
+msgid "Passwords do not match"
+msgstr ""
+
+#: sss_client/pam_sss.c:411
+msgid "Offline authentication"
+msgstr ""
+
+#: sss_client/pam_sss.c:412
+msgid ", your cached password will expire at: "
+msgstr ""
+
+#: sss_client/pam_sss.c:462
+msgid "Offline authentication, authentication is denied until: "
+msgstr ""
+
+#: sss_client/pam_sss.c:489
+msgid "System is offline, password change not possible"
+msgstr ""
+
+#: sss_client/pam_sss.c:519
+msgid "Password change failed. "
+msgstr ""
+
+#: sss_client/pam_sss.c:520
+msgid "Server message: "
+msgstr ""
+
+#: sss_client/pam_sss.c:855
+msgid "Password: "
+msgstr ""
+
+#: sss_client/pam_sss.c:887
+msgid "New Password: "
+msgstr ""
+
+#: sss_client/pam_sss.c:888
+msgid "Reenter new Password: "
+msgstr ""
+
+#: sss_client/pam_sss.c:1092
+msgid "Password has expired."
+msgstr ""
diff --git a/server/po/sv.po b/server/po/sv.po
index dc3645a..f5be1b1 100644
--- a/server/po/sv.po
+++ b/server/po/sv.po
@@ -8,7 +8,7 @@ msgid ""
 msgstr ""
 "Project-Id-Version: sss_server\n"
 "Report-Msgid-Bugs-To: sssd-devel@lists.fedorahosted.org\n"
-"POT-Creation-Date: 2010-02-05 09:37-0500\n"
+"POT-Creation-Date: 2010-02-17 09:21-0500\n"
 "PO-Revision-Date: 2009-12-30 17:58+0100\n"
 "Last-Translator: Göran Uddeborg <goeran@uddeborg.se>\n"
 "Language-Team: Swedish <tp-sv@listor.tp-sv.se>\n"
@@ -664,3 +664,48 @@ msgstr ""
 #: tools/sss_usermod.c:249
 msgid "Transaction error. Could not modify user.\n"
 msgstr "Transaktionsfel.  Det gick inte att ändra användaren.\n"
+
+#: sss_client/pam_sss.c:342
+msgid "Passwords do not match"
+msgstr "Lösenorden stämmer inte överens"
+
+#: sss_client/pam_sss.c:411
+msgid "Offline authentication"
+msgstr ""
+
+#: sss_client/pam_sss.c:412
+msgid ", your cached password will expire at: "
+msgstr ""
+
+#: sss_client/pam_sss.c:462
+msgid "Offline authentication, authentication is denied until: "
+msgstr ""
+
+#: sss_client/pam_sss.c:489
+msgid "System is offline, password change not possible"
+msgstr ""
+
+#: sss_client/pam_sss.c:519
+#, fuzzy
+msgid "Password change failed. "
+msgstr "Leverantör av lösenordsändringar"
+
+#: sss_client/pam_sss.c:520
+msgid "Server message: "
+msgstr ""
+
+#: sss_client/pam_sss.c:855
+msgid "Password: "
+msgstr "Lösenord: "
+
+#: sss_client/pam_sss.c:887
+msgid "New Password: "
+msgstr "Nytt lösenord: "
+
+#: sss_client/pam_sss.c:888
+msgid "Reenter new Password: "
+msgstr "Skriv det nya lösenordet igen: "
+
+#: sss_client/pam_sss.c:1092
+msgid "Password has expired."
+msgstr "Lösenordet har gått ut."
-- 
1.6.6