--- samadhi.master.ca_vell.po	2009-05-31 23:07:45.000000000 +0200
+++ samadhi.master.ca.po	2009-05-30 22:21:53.000000000 +0200
@@ -24,6 +24,7 @@
 "POT-Creation-Date: 2008-02-21 09:19-0600\n"
 "PO-Revision-Date: 2009-05-17 17:34+0100\n"
 "Last-Translator: Xavier Conde Rueda <xavi.conde@gmail.com>\n"
+"Last-Translator: Salva Pascual <salva@delleida.com>\n"
 "Language-Team: Catalan <fedora@softcatala.net>\n"
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=UTF-8\n"
@@ -35,30 +36,31 @@
 "The credentials you supplied were not correct or did not grant access to "
 "this resource."
 msgstr ""
-
+"La identitat que has subministrat no eren correctes o no concedeix l'accès"
+"a aquest recurs."
 #: samadhi/controllers.py:118
 msgid "You must provide your credentials before accessing this resource."
-msgstr ""
+msgstr "Has de proporcionar la teva identitat abans d'accedir a aquest recurs."
 
 #: samadhi/controllers.py:121
 msgid "Please log in."
-msgstr ""
+msgstr "Si us plau inicia la sessió"
 
 #: samadhi/templates/about.html:6
 msgid "This is an OpenID server"
-msgstr ""
+msgstr "Aquest és el servidor OpenID"
 
 #: samadhi/templates/about.html:11
 msgid "This"
-msgstr ""
+msgstr "Aquest"
 
 #: samadhi/templates/about.html:11
 msgid "is an OpenID server endpoint."
-msgstr ""
+msgstr "és el punt final del servidor OpenID."
 
 #: samadhi/templates/about.html:12
 msgid "For more information about OpenID, see:"
-msgstr ""
+msgstr "Per més informació quant a Open ID, mira:"
 
 #: samadhi/templates/about.html:14
 msgid "http://www.openidenabled.com/"
@@ -66,7 +68,7 @@
 
 #: samadhi/templates/about.html:15
 msgid "An OpenID community web site, home of this library."
-msgstr ""
+msgstr "Lloc web de la comunitat OpenID"
 
 #: samadhi/templates/about.html:16
 msgid "http://www.openid.net/"
@@ -74,13 +76,13 @@
 
 #: samadhi/templates/about.html:17
 msgid "The official OpenID web site."
-msgstr ""
+msgstr "Lloc web oficial OpenID"
 
 #: samadhi/templates/authorizesite.html:6
 #: samadhi/templates/authorizesite.html:10
 #: samadhi/templates/loginasdifferentuser.html:6
 msgid "Approve OpenID Request?"
-msgstr ""
+msgstr "Sol·liciud aprovada OpenID?"
 
 #: samadhi/templates/authorizesite.html:11
 msgid ""
@@ -90,34 +92,38 @@
 "      you are using a delegated identity, the site will take\n"
 "      care of reversing the delegation on its own.)"
 msgstr ""
-
+"Un nou lloc que pregunta per confirmar la teva identitat.\n "
+"	Si tu autoritzes, el lloc que està representat per l'arrel de confiança\n"
+"	et dira que tu controles la identitat URL de la llista.\n "
+"	(Si tu estàs utilitzant un delegat d'identitat, el lloc s'encarregarà\n"
+"	de invertir la tendència a la seva propia delegació.)"
 #: samadhi/templates/authorizesite.html:17 samadhi/templates/idselect.html:19
 #: samadhi/templates/loginasdifferentuser.html:16
 msgid "Identity:"
-msgstr ""
+msgstr "Identitat"
 
 #: samadhi/templates/authorizesite.html:18 samadhi/templates/idselect.html:23
 #: samadhi/templates/loginasdifferentuser.html:17
 msgid "Trust Root:"
-msgstr ""
+msgstr "Àrrel de confiança:"
 
 #: samadhi/templates/authorizesite.html:20 samadhi/templates/idselect.html:27
 #: samadhi/templates/loginasdifferentuser.html:19
 msgid "Allow this authentication to proceed?"
-msgstr ""
+msgstr "Autoritzar la autenticació per continuar?"
 
 #: samadhi/templates/authorizesite.html:23 samadhi/templates/idselect.html:29
 #: samadhi/templates/loginasdifferentuser.html:22
 msgid "Remember this decision"
-msgstr ""
+msgstr "Recorda aquesta desició"
 
 #: samadhi/templates/id.html:8
 msgid "An Identity Page"
-msgstr ""
+msgstr "Pàgina d'identificació"
 
 #: samadhi/templates/idselect.html:6
 msgid "Select an Identity"
-msgstr ""
+msgstr "Selecciona i identificat"
 
 #: samadhi/templates/idselect.html:10
 msgid ""
@@ -127,14 +133,14 @@
 "      of pre-created accounts or have the facility to generate\n"
 "      a random anonymous identifier."
 msgstr ""
-
-#: samadhi/templates/login.html:7 samadhi/templates/login.html:11
-msgid "Login"
-msgstr "Entrada"
-
+"Un lloc ha demanat per la seva identitat. Tu pots seleccionar un\n"
+"	identificador que t'agradi per utilitzar amb aquest lloc web.\n"
+"	Una presentació del lloc que t'agradaria per baixar comptes\n"
+"	pre-creats d'una llista o tenir la facilitat de generar\n"
+"	identificadors anònims aleatoris" 
 #: samadhi/templates/login.html:17
 msgid "User Name:"
-msgstr "Nom d'usuar:"
+msgstr "Nom d'usuari:"
 
 #: samadhi/templates/login.html:25
 msgid "Password:"
@@ -142,17 +148,19 @@
 
 #: samadhi/templates/loginasdifferentuser.html:10
 msgid "A site has asked for an identity belonging to"
-msgstr ""
+msgstr "El lloc web ha preguntat una identitat pertanyent"
 
 #: samadhi/templates/loginasdifferentuser.html:11
 msgid ", but you are logged in as"
-msgstr ""
+msgstr ", però tu has iniciat la sessió"
 
 #: samadhi/templates/loginasdifferentuser.html:11
 msgid ""
 ".  To\n"
 "      log in as"
 msgstr ""
+".  Per\n"
+"       inicia la sessió"
 
 #: samadhi/templates/loginasdifferentuser.html:12
 msgid ""
@@ -160,23 +168,26 @@
 "      hit OK below.  The \"Remember this decision\" checkbox\n"
 "      applies only to the trust root decision."
 msgstr ""
-
+"i aprovar la sol·licitud d'inici de sessió,"
+"	i per aconseguir-ho. El \"Recorda aquest desició\" "
+"	casella de selecció \n sol s'aplica a la desició\n"
+"	de l'arrel de confiança."
 #: samadhi/templates/welcome.html:7
 msgid "Welcome to the Fedora OpenID Provider"
-msgstr ""
+msgstr "Benvingut al Proveïdor OpenId de Fedora"
 
 #: samadhi/templates/welcome.html:13
 msgid "You are logged in as"
-msgstr ""
+msgstr "Tu has iniciat la sessió"
 
 #: samadhi/templates/welcome.html:13
 msgid ". Your OpenID identity URL is"
-msgstr ""
+msgstr ". La teva URL d'identificació OpenID és"
 
 #: samadhi/templates/welcome.html:17
 msgid "You are not"
-msgstr ""
+msgstr "Tú no has"
 
 #: samadhi/templates/welcome.html:17
 msgid "logged in"
-msgstr ""
+msgstr "inciat la sessió"